<script setup lang="ts">
import { ref } from 'vue';
import GitLabIcon from '~/assets/icons/gitlab.vue';
import type { FooterData } from '@/types/navigation';

defineProps<{
  footerData: FooterData;
}>();

const maxLinksPerColumnMobile = ref(10);

//localization data
const route = useRoute();
const availableLanguages = useAvailableLanguages(route.path);
</script>

<template>
  <footer id="be-footer" class="be-nav-footer">
    <SlpContainer class="footer__container">
      <SlpRow class="footer__navigation">
        <SlpColumn :cols="2" class="logo">
          <GitLabIcon />
          <span>®</span>
        </SlpColumn>
        <SlpColumn v-if="footerData" :cols="10" class="content">
          <div
            v-for="item in footerData.items"
            :key="item.title"
            class="column"
            :class="{
              column__nested: (item.links?.length ?? 0) > maxLinksPerColumnMobile,
            }"
          >
            <div
              :class="{
                divided: (item.links?.length ?? 0) > maxLinksPerColumnMobile,
              }"
            >
              <section>
                <header>
                  <SlpTypography tag="h3" variant="body1-bold" class="column__heading">
                    {{ item.title }}
                  </SlpTypography>
                </header>
                <ul
                  class="links"
                  :class="{
                    links__divided: (item.links?.length ?? 0) > maxLinksPerColumnMobile,
                  }"
                >
                  <li v-for="link in item.links" :key="link.text" class="links__item">
                    <NavigationFooterOneTrustCookieButton v-if="link.config?.isOneTrustButton" :link="link" />
                    <a
                      v-else
                      :href="link.config.href"
                      class="link"
                      :data-ga-location="link.config.dataGaLocation"
                      :data-ga-name="link.config.dataGaName"
                    >
                      {{ link.text }}
                    </a>
                  </li>
                </ul>
              </section>
            </div>
            <div v-if="item.subMenu" class="column-wrapper">
              <div v-for="nestedItem in item.subMenu" :key="nestedItem.title" class="column">
                <section>
                  <header>
                    <SlpTypography tag="h3" variant="body1-bold" class="column__heading">
                      {{ nestedItem.title }}
                    </SlpTypography>
                    <ul class="links">
                      <li v-for="link in nestedItem.links" :key="link.text" class="links__item">
                        <NavigationFooterOneTrustCookieButton v-if="link.config?.isOneTrustButton" :link="link" />
                        <a
                          v-else
                          :href="link.config.href"
                          class="link"
                          :data-ga-location="link.config.dataGaLocation"
                          :data-ga-name="link.config.dataGaName"
                        >
                          {{ link.text }}
                        </a>
                      </li>
                    </ul>
                  </header>
                </section>
              </div>
            </div>
          </div>
        </SlpColumn>
      </SlpRow>
      <div class="footer__cta">
        <div
          class="footer__selectors"
          :class="{
            'footer__selectors--two-children': availableLanguages && availableLanguages.length > 1,
          }"
        >
          <div v-if="availableLanguages.length && availableLanguages.length > 1">
            <NavigationFooterLanguageSelector />
          </div>
          <NavigationFooterSocialMediaLinks v-bind="footerData.config" />
        </div>
        <NavigationFooterSource v-bind="footerData" />
      </div>
    </SlpContainer>
  </footer>
</template>

<style lang="scss" scoped>
.be-nav-footer {
  background-color: $color-surface-700;
  color: $color-text-50;
  padding: 40px $spacing-16;
  overflow: hidden;

  *,
  ::before,
  ::after {
    box-sizing: border-box;
  }

  .disclaimer {
    background: $color-surface-100;
    padding: 32px 0;
  }

  .container {
    @media (max-width: $breakpoint-md) {
      padding: 0 !important;
    }
  }

  .footer__navigation {
    display: flex;
    justify-content: space-between;
    align-items: flex-start;
    flex-wrap: wrap;
    flex-direction: column;
    @media (min-width: 1220px) {
      flex-direction: row;
      flex-wrap: nowrap;
    }
  }

  .logo {
    margin: 0 auto 0 0;
    display: flex;

    span {
      margin-left: $spacing-4;
      font-size: $text-body-1;
    }
  }

  .content {
    display: flex;
    margin-top: $spacing-48;
    justify-content: space-between;
    flex-wrap: wrap;
    gap: 30px;
    @media (min-width: 1220px) {
      margin-top: 0;
    }
  }

  .column-wrapper {
    @media (min-width: $breakpoint-md + 1px) {
      margin-top: $spacing-24;
    }
  }

  .column {
    max-width: 150px;
    width: 100%;
    flex: 1 0 auto;
    min-width: 2rem;

    &__heading {
      margin-bottom: $spacing-16;
    }

    &__nested {
      @media (max-width: $breakpoint-md) {
        max-width: 100%;
        display: flex;
        align-items: flex-start;
        justify-content: space-between;
        gap: 30px;

        & > * {
          width: 145px;
        }
      }
    }
    @media (min-width: $breakpoint-md) {
      max-width: 160px;
    }
  }

  .divided {
    @media (max-width: $breakpoint-md) {
      width: 100%;
    }
  }
  .links {
    &__item {
      margin-bottom: $spacing-8;
      &:hover {
        text-decoration: underline;
      }
    }
    &__divided {
      @media (max-width: $breakpoint-md) {
        columns: 120px 2;
        column-gap: calc(100% - 290px);
      }
    }
  }

  .link {
    font-size: $text-body-3;
    line-height: $line-height-body-3;
    color: $color-text-50;
  }

  .footer__cta {
    display: flex;
    flex-direction: column;
    padding-top: $spacing-64;
    @media (min-width: $breakpoint-md) {
      padding-top: $spacing-96;
    }
  }

  .footer__selectors {
    display: flex;
    justify-content: flex-end;
    border-bottom: 1px solid $color-primary-300;
    padding-bottom: $spacing-24;
    margin-bottom: $spacing-32;
    flex-direction: column;
    align-items: baseline;

    @media (min-width: $breakpoint-md) {
      flex-direction: row;
    }

    &--two-children {
      justify-content: space-between;
    }
  }

  &__source-buttons {
    display: flex;
    flex-wrap: wrap;
    gap: 8px 24px;
  }

  &__button {
    color: $color-text-50;
    text-decoration: underline;
    border: none;
    padding: 0;
    cursor: pointer;
    font-weight: $font-weight-bold;
    font-size: $text-body-3;

    &--black {
      color: $color-text-300;
    }
  }
  .source {
    p {
      margin-bottom: $spacing-8;
      font-size: $text-body-3;
    }

    a {
      font-weight: $font-weight-bold;
      color: $color-text-50;
      text-decoration: underline;
    }

    img {
      display: inline-block;
      vertical-align: middle;
      margin-left: 5px;
    }
  }

  // OneTrust button in footer
  #ot-sdk-btn.ot-sdk-show-settings,
  #ot-sdk-btn.optanon-show-settings {
    color: $color-text-50 !important;
    border: 0 !important;
    border: none !important;
    padding: 0 !important;
    font-size: 14px !important;
    font-family: 'GitLab Sans', sans-serif !important;
    text-align: left !important;
    cursor: pointer;

    &:hover {
      text-decoration: underline;
      background: inherit;
    }
  }
}
</style>
